//Name: TypeDefBase.h
//Latest update: 2013.02.23 by Longshu Yang(D.E.Rommel).
//Description: The abbreviation form of STL data structures.

#ifndef TYPEDEFBASE_H
#define TYPEDEFBASE_H

#include<vector>
#include<utility>
typedef std::vector<std::vector<std::vector<double> > > Ve_Ve_Ve_D;
typedef std::vector<int> Ve_I;
typedef std::vector<std::string> Ve_Str;
typedef std::vector<std::vector<std::string> > Ve_Ve_Str;
typedef const std::vector<int> con_Ve_I;
typedef std::vector< std::pair<int,int> > Ve_Pa_I_I;
typedef std::vector<double> Ve_D;
typedef const std::vector<double> con_Ve_D;
typedef std::vector< std::vector<int> > Ve_Ve_I;
typedef std::vector< std::vector<double> > Ve_Ve_D;
typedef std::vector< double* > Ve_D_Ptr;
typedef std::vector< std::vector<double>* > Ve_Ve_D_Ptr;
typedef const std::vector< std::vector<double> > con_Ve_Ve_D;
typedef std::vector< std::pair<std::string, int> > Ve_Pa_Str_I;
typedef std::vector< std::pair<std::string, bool> > Ve_Pa_Str_B;
typedef std::pair<int, int> Pa_I_I;
typedef std::pair<int, double> Pa_I_D;
typedef std::pair<bool, double> Pa_B_D;
typedef std::pair<bool, int> Pa_B_I;
typedef std::pair<double, double> Pa_D_D;
typedef std::pair<double, int> Pa_D_I;
typedef std::pair<char,char> Pa_C_C;
typedef const std::pair<int, int> con_Pa_I_I;
typedef std::pair<std::string, int> Pa_Str_I;
typedef std::pair<std::string, bool> Pa_Str_B;
typedef std::vector< std::pair< double, double > > Ve_Pa_D_D;
typedef std::vector< std::pair< double, int > > Ve_Pa_D_I;
typedef std::vector< std::pair< char, int > > Ve_Pa_C_I;
typedef std::pair< std::vector< double >,std::vector< int > > Pa_Ve_D_Ve_I;
typedef std::pair<std::string, std::string > Pa_Str_Str;
typedef std::vector< std::pair< std::string, std::string > > Ve_Pa_Str_Str;
typedef std::vector< std::pair< std::string, double > > Ve_Pa_Str_D;
typedef std::vector< bool > Ve_B;
typedef std::vector< std::pair< bool, bool > > Ve_Pa_B_B;

#include<fstream>
typedef std::ifstream Ifstream;
typedef std::ofstream Ofstream;
typedef std::ostream Ostream;
typedef std::istream Istream;

#include<string>
typedef std::string Str;
typedef const std::string con_Str;

#include<deque>
typedef const std::deque< int > con_De_I; 
typedef std::deque< int > De_I; 
typedef std::deque<std::string> De_Str;
typedef std::deque<std::pair<std::string, std::string> > De_Pa_Str_Str;

#include<map>
typedef std::map< int, int > Map_I_I;
typedef std::map< int, std::string > Map_I_Str;
typedef std::map< std::string, int > Map_Str_I;
typedef std::map< Str, Str > Map_Str_Str;
typedef std::map< Str, double > Map_Str_D;
typedef std::map< Str, std::pair< int, int > > Map_Str_Pa_I_I;
typedef std::map<char, double> Map_C_D;
typedef std::vector<std::map<char,double> > Ve_Map_C_D;

#include<set>
typedef std::set<int> Set_I;
typedef std::set<Str> Set_Str;
typedef std::set<double> Set_D;

//#include<limits>
//typedef std::numeric_limits<int> int_limits;

#include<list>
typedef std::list< std::pair< double, double > > List_Pa_D_D;
typedef std::list< int > List_I;
typedef std::list<Str> List_Str;

#include<iostream>
#include<iomanip>
#include"assert.h"
#include<algorithm>
#include<cstdio>
#include<sstream>
#include<cmath>
#endif //TYPEDEFBASE_H